#!/usr/bin/perl

#
# command line:  perl infer-batch.pl initial.dat tier1.txt ratio asrelationship.txt tempdir RIPE00 pattern OREGON pattern
#

if( !($#ARGV==8 || $#ARGV==6) )
{
    print "\n arguments:  initial.dat tier1.txt filter-ratio asrelationship.txt tempdir [RIPE00 pattern] [OREGON pattern]\n"; exit;
}

$initial = $ARGV[0];
$tier1as = $ARGV[1];
$ratio = $ARGV[2];
$asrelation = $ARGV[3];
$tempdir = $ARGV[4]; $tempdir =~ s/\/$//;

if( $ARGV[5] eq "RIPE00" )
{
    @ripe00 = `ls $ARGV[6]*`;
    $arg_ripe00 = 6;
}

if( $ARGV[5] eq "OREGON" )
{
    @oregon = `ls $ARGV[6]*`;
    $arg_oregon = 6;
}

if( $ARGV[7] eq "RIPE00" )
{
    @ripe00 = `ls $ARGV[8]*`;
    $arg_ripe00 = 8;
}

if( $ARGV[7] eq "OREGON" )
{
    @oregon = `ls $ARGV[8]*`;
    $arg_oregon = 8;
}


print " debug:  tables RIPE00 ", $#ripe00+1, "  and OREGON ", $#oregon+1, " \n";
print " @ripe00 @oregon\n";

#### step 1
if( $#ripe00>=0 )
{
    foreach $file ( @ripe00 )
    {
        chomp($file); @v = split(/\//, $file);
        system("~/bin/route_btoa -i -m $file | cut -f7 -d'|' > $tempdir/$v[$#v].aspath");
    }
}

if( $#oregon>=0 )
{
    system("perl ~/bin/infer-exec/inferas_PTE/tools-preprocess_shipbgp.pl $ARGV[$arg_oregon] $tempdir");
}


#### step 2a :: filter transient misconfiguration
##perl infer-filter-transit-misconf.pl

print " now filtering transient misconfigurations\n";

$file_after_filter_transient_misconf_RIPE00 = "$tempdir/ripe00.aspath-after-filter-transient-misconf";
$file_after_filter_transient_misconf_OREGON = "$tempdir/oregon.aspath-after-filter-transient-misconf";

if( $#ripe00>=0 )
{
        @v = split(/\//, $ARGV[$arg_ripe00]);
        $cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-filter-transient-misconf.pl";
        system(" $cmd1  $tempdir/$v[$#v] $ratio $file_after_filter_transient_misconf_RIPE00 ");
}

if( $#oregon>=0 )
{
        @v = split(/\//, $ARGV[$arg_oregon]);
        $cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-filter-transient-misconf.pl";
        system(" $cmd1  $tempdir/$v[$#v] $ratio $file_after_filter_transient_misconf_OREGON ");
}

#### step 2b :: filter policy misconfiguration

print " now filtering policy (or valley-free) misconfigurations\n";

$file_after_filter_policy_misconf_RIPE00 = "$tempdir/ripe00.aspath-after-filter-policy-misconf";
$file_after_filter_policy_misconf_OREGON = "$tempdir/oregon.aspath-after-filter-policy-misconf";

if( $#ripe00>=0 )
{
        @v = split(/\//, $ARGV[$arg_ripe00]);
        $cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-filter-policy-misconf.pl";
        system(" $cmd1 $file_after_filter_transient_misconf_RIPE00 $initial $file_after_filter_policy_misconf_RIPE00 $tier1as");
}

if( $#oregon>=0 )
{
        @v = split(/\//, $ARGV[$arg_oregon]);
        $cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-filter-policy-misconf.pl";
        system(" $cmd1 $file_after_filter_transient_misconf_OREGON $initial $file_after_filter_policy_misconf_OREGON $tier1as");
}

#### step 3 :: infer-asrelationship

print " now inferring AS relationships\n";

$aspathfile = "$tempdir/combine-all.aspath";
$asrelfile = "$tempdir/asrelation.before-remove-loops";
system("cat $file_after_filter_policy_misconf_RIPE00 $file_after_filter_policy_misconf_OREGON  > $aspathfile");

$cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-by-valley-free.pl";
system(" $cmd1 $aspathfile $initial $asrelfile $tier1as");

#### step 4 :: remove loops

print " now removing AS relationship loops\n";
$asrel_before_remove_loops = "$tempdir/asrelation.before-remove-loops";
$asrel_after_remove_loops = "$tempdir/asrelation.after-remove-loops";

$cmd1 = "perl ~/bin/infer-exec/inferas_PTE/infer-remove-loops.pl ";
system(" $cmd1 $asrel_before_remove_loops $asrel_after_remove_loops  $tier1as");

system(" cp $asrel_after_remove_loops $asrelation ");

print "done.\n";
