#!/usr/bin/perl

if( $#ARGV!=3 )
{
    print "arguments: aspath-file asrelation-file output-file tier1as.txt\n"; exit;
}

$aspath_file  = $ARGV[0];
$asrel_file = $ARGV[1];
$output_file = $ARGV[2];
$tier1as = $ARGV[3];
$summary_file = "$output_file.summary";



#===========read known AS relatonship =======
open(INPUT, "$asrel_file") || die("can not read $asrel_file");
while(<INPUT>)
{
    chomp($_);  @r = split(/\s+/, $_);
    if( $r[1]>0 && $r[2]>0 )
    {
        SetRel($r[1], $r[2], $r[3]);
    }
}
close(INPUT);

##========= read Tier 1 AS =============
$string_tier1as = " ";
open(INPUT, "$tier1as") || die("can not read $tier1as");
while(<INPUT>)
{
    chomp($_);
    @r = split(/\s+/, $_);
    if( $r[0]>0 && $string_tier1as !~ / $r[0] / )
    {
        $string_tier1as = join(" ", $string_tier1as, " $r[0] ");
    }
}
close(INPUT);

open(INPUT, "$aspath_file") || die("can not read $aspath_file");
open(OUTPUT, ">$output_file") || die("can not write $output_file");
open(SUMMARY, ">$summary_file") || die("can not write $summary_file");;

$count_filter = 0;
$count_passed = 0;

while(<INPUT>)
{
    chomp($_);
    $valley = " ";
    @r = split(/\s+/, $_);

    $toptier = " ";
    $min = $#r + 1; $max = -1;
    for($i=0; $i<=$#r; $i++)
    {
        last if ($r[$i]==0);
        if( $r[$i]>0 && $string_tier1as =~ / $r[$i] / )
        {
            $toptier = join(" ", $toptier, "T");
            if( $max<=$i )
            {
                $max = $i;
            }
            if( $min>=$i )
            {
                $min = $i;
            }
        }
        elsif ( $r[$i]>0 )
        {
            $toptier = join(" ", $toptier, "o");
        }
    }

    $toptier =~ s/ //g;
    $interval = $max - $min;

    for($i=0; $i<$#r; $i++)
    {
        last if( $r[$i]==0 || $r[$i+1]==0 );
        if( $r[$i]>0 && $r[$i+1]>0 && $r[$i]!=$r[$i+1])
        {
            $valley = join(" ", $valley, " $asrel{$r[$i], $r[$i+1]} ");
        }
    }

    $ori_valley = $valley;
    $ori_valley =~ tr/ / /s;
    $valley =~ s/-/ /g;
    $valley =~ s/S/ /g;
    $valley =~ s/ //g;
    $valley =~ tr/C/C/s;
    $valley =~ tr/P/P/s;

    #if( $interval >=2 )
    #{
    #    print FILTER " ::top tier:: $toptier :: $ori_valley ::   $_  \n";
    #    $count_filter++;
    #}

    #els
    if( $valley eq "C" || $valley eq "CP" || $valley eq "CE"  || $valley eq "CEP"
        ||$valley eq "E" || $valley eq "EP" || $valley eq "P" || $valley eq "")
    {
        print OUTPUT "$_\n";
        $count_passed++;
    }
    else
    {
        print SUMMARY " ::valley:: $ori_valley :: $toptier ::   $_  \n";
        $count_filter++;
    }
}

$total = $count_passed + $count_filter;
print SUMMARY " ::summary:: total $total  passed $count_passed  filtered: $count_filter \n";

close(INPUT);
close(OUTPUT);
close(SUMMARY);


sub SetRel {
    local($as1, $as2, $rel) = @_;
    local($rrel);

    $rrel = $rel;
    if( $rel eq "P" ) { $rrel = "C"; }
    if( $rel eq "C" ) { $rrel = "P"; }
    if( $asrel{$as1, $as2} !~ /$rel/ )
    {
        $asrel{$as1, $as2} = join("", $asrel{$as1, $as2}, $rel);
        $asrel{$as2, $as1} = join("", $asrel{$as2, $as1}, $rrel);
    }
}

sub numerically  {         $a  <=>         $b ;}
sub cnumerically { $asccnt{$b} <=> $asccnt{$a};}
