#!/usr/bin/perl

if( $#ARGV!=2 )
{
    print "arguments: aspath-file-pattern  ratio outputfile\n"; exit;
}


$filepattern = $ARGV[0];
$ratio = $ARGV[1];
$outfile = $ARGV[2];
$summary_file = "$outfile.summary";

@files = `ls $filepattern*`;
$num_files = $#files + 1;
print "\n there are $num_files aspath-files ::\n @files\n";

$total_aspaths = 0;
$total_unique_aspaths = 0;
$filter_aspaths = 0;
$valid_aspaths = 0;

foreach $filename (@files)
{
    chomp($filename);
    open(INF, $filename) || die("can not read $filename");
    while(<INF>)
    {
        chomp($_); $_ =~ tr/ / /s; $_=~ s/^ //g; $_ =~ s/ $//g;
        if( $_ ne "" )
        {
            $exist{$_} = 1;
            $total_aspaths++;
        }
    }
    close(INF);

    foreach $path ( keys %exist )
    {
        $count{$path}++;
    }
    delete @exist { keys %exist }; 
}

open(OUT, ">$outfile") || die("can not write $outfile");
open(SUMMARY, ">$summary_file") || die("can not write $summary_file");

foreach $path ( keys %count )
{
    $total_unique_aspaths++;
    if( $count{$path} >= $ratio * $num_files )
    {
        print OUT "$path\n";
        $valid_aspaths++;
    }
    else
    {
        $filter_aspaths++;
        print SUMMARY "in $count{$path} files :::: $path\n"; 
    }
}
close(OUT);
print SUMMARY " summary :: total paths = $total_aspaths  unique paths = $total_unique_aspaths  filtered = $filter_aspaths valid = $valid_aspaths\n";
close(SUMMARY);


