#!/usr/bin/perl

#
#  find the loop;
#  find the maximum degree AS in the loop
#  find small provider loop with maximum degree AS
#  overwrite AS relationship with smallest C/P degree ratio
#


$RATIO = 1;

if( $#ARGV != 2 )
{
    print "arguments:  asrelationship.txt asrelationship.noloops tier1as.txt\n"; exit;
}

$old_asrel_file  = $ARGV[0];
$new_asrel_file = $ARGV[1];
$tier1as = $ARGV[2];

##========= read Tier 1 AS =============
$string_tier1as = " ";
open(T1AS, "$tier1as") || die("can not read $tier1as");
while(<T1AS>)
{
    chomp($_);
    @r = split(/\s+/, $_);
    if( $r[0]>0 && $string_tier1as !~ / $r[0] / )
    {
        $string_tier1as = join(" ", $string_tier1as, " $r[0] ");
    }
}
close(T1AS);

#===========read known AS relatonship && degree=======
open(INPUT,"$old_asrel_file") || die("can not read $old_asrel_file");
while(<INPUT>)
{
    chomp($_);
    @r = split(/\s+/, $_);
    if( $r[1]>0 && $r[2]>0 && $r[1]!=$r[2] )
    {
        if( $r[3] eq "P" || $r[3] eq "C" || $r[3] eq "E" || $r[3] eq "S" )
        {
            $asrel{$r[1], $r[2]} = $r[3];
            if( $r[3] eq "C" ) { $asrel{$r[2], $r[1]} = "P"; }
            elsif ( $r[3] eq "P" ) { $asrel{$r[2], $r[1]} = "C"; }
            elsif( $r[3] eq "E" || $r[3] eq "S" ) { $asrel{$r[2], $r[1]} = $r[3]; }
        }
        $degree{$r[1]}++;
        $degree{$r[2]}++;
    }
}
close(INPUT);

$times=0;

REPEAT:
## $times++;
GetASesWithPossibleLoops();

FindLargestRatio();

$AS_maxdegree = 0;
foreach $key ( keys %subgraph )
{
    if( $degree{$key} > $degree{$AS_maxdegree} && $subgraph{$key}==1  )
    {
        $AS_maxdegree = $key;
    }
}

##print " debug MaxDegreeAS = $AS_maxdegree \n";

if( $AS_maxdegree == 0 )
{
    open(OUT, ">$new_asrel_file ") || die("can not write $new_asrel_file ");
    foreach $key ( keys %asrel )
    {
        ($as1, $as2) = split($;, $key);
        if( $as1<$as2 ) { print OUT " $as1 $as2 $asrel{$key} \n"; }
    }
    close(OUT);
    exit;
}

if( $times<=10 ) { goto REPEAT; }

sub GetASesWithPossibleLoops
{
    local(@has_customer, @has_provider);
    local($cnt_subgraph, $cnt_subgraph_old);

    # print "  subgraph: ";

    ## reset @subgraph and @subasrel
    foreach $key ( keys %asrel )
    {
        ($v1, $v2) = split($;, $key);
        $subgraph{$v1} = 1; $subgraph{$v2} = 1;
        $has_customer{$key} = 0;
        $has_provider{$key} = 0;
        $subasrel{$key} = $asrel{$key};
    }

    $cnt_subgraph_old = $cnt_subgraph;

  REPEAT_FIND_SUBGRAPH:

    foreach $key ( keys %subasrel )
    {
        ($v1, $v2) = split( $;, $key );
        if( $subgraph{$v1}==1 && $subgraph{$v2}==1 )
        {
            if( $subasrel{$v1, $v2} eq "P" ) {
                $has_customer{$v1} = 1;
                $has_provider{$v2} = 1;
            }
            elsif( $subasrel{$v1, $v2} eq "C" ) {
                $has_provider{$v1} = 1;
                $has_customer{$v2} = 1;
            }
        }
    }

    $cnt_subgraph = 0;
    foreach $key ( keys %subgraph )
    {
        if( $has_customer{$key}==1 && $has_provider{$key}==1 )
        {
            $subgraph{$key} = 1;
            $has_customer{$key} = 0;
            $has_provider{$key} = 0;
            $cnt_subgraph++;
        }
        else
        {
            delete $subgraph{$key};
        }
    }

    foreach $key ( keys %subasrel )
    {
        ($v1, $v2) = split( $;, $key );
        if( $subgraph{$v1}==1 && $subgraph{$v2}==1 )
        {
        }
        else
        {
            delete $subasrel{$key};
        }
    }

    # print " $cnt_subgraph ";
    if( $cnt_subgraph == $cnt_subgraph_old )
    {
        # print "\n";
        return @subgraph;
    }
    else
    {
        $cnt_subgraph_old = $cnt_subgraph;
        goto REPEAT_FIND_SUBGRAPH;
    }
}


sub FindLargestRatio()
{
    local($max, $as1, $as2);
    $max = 0;

    foreach $key ( keys %subasrel )
    {
        ($v1, $v2) = split($;, $key);
        if( $subasrel{$v1, $v2} eq "C" )
        {
            $ratioCP = $degree{$v1}/$degree{$v2};
            if( $max < $ratioCP )
            {
                $max = $ratioCP;
                $as1 = $v1;
                $as2 = $v2;
            }
        }
    }
    # print " $as1 $as2 $subasrel{$as1, $as2} :: $degree{$as1} $degree{$as2} :: $max modified \n";
    if( $max >=1 )
    {
        $asrel{$as1, $as2} = "P"; $asrel{$as2, $as1} = "C";
    }
    else
    {
        $asrel{$as1, $as2} = "E"; $asrel{$as2, $as1} = "E";
    }
}
